#ifndef ROGUE_CHARACTER_H
#define ROGUE_CHARACTER_H

#include "core/roguedefs.h"

namespace rogue {
class World;
class Character;

typedef Tile(&CharacterLogicFunction)(Character &character);

struct CharacterData {
	int health{1};
	int damage{1};
	Sprite sprite{0};
	CharacterLogicFunction logic;
};

struct Character {
	Character(World &world, Tile location, CharacterData stats);

	void act();
	void draw();
	bool deal_damage(int damage);

	CharacterData const data;
	int health{1};
	Tile location{0, 0};
	World &world;
};

extern Tile null_character_logic_function(Character &character);
}

#endif // !ROGUE_CHARACTER_H
