#include "world.h"
#include "core/character.h"
#include <cassert>

namespace rogue {
void Room::draw() {
	// TODO: .
}

bool Room::tile_is_wall(Tile local_tile) const {
	// TODO: I wonder what
	return false;
}

void World::act() {
	for(Character &character : this->characters) {
		character.act();
	}
}

void World::render() {
	for(Room &room : this->rooms) {
		room.draw();
	}
	for(Character &character : this->characters) {
		character.draw();
	}
}

Room &World::get_room(Chunk chunk) {
	return rooms[chunk.x + chunk.y * this->shear];
}

TileData World::query_tile(Tile tile) {
	Room &room{this->get_room({tile.x / this->chunk_size, tile.y / this->chunk_size})};
	TileData out{
		.character = nullptr,
		.is_wall = room.tile_is_wall({tile.x % this->chunk_size, tile.y % this->chunk_size})
	};
	for(Character &character : this->characters) {
		if(character.location == tile) {
			out.character = &character;
			return out;
		}
	}
	return out;
}

WorldGenerator &WorldGenerator::with_chunk_size(unsigned side_length) {
	assert(this->chunk_side_length == 0);
	assert(side_length > 0);
	this->chunk_side_length = side_length;
	return *this;
}

WorldGenerator &WorldGenerator::with_world_size(unsigned side_length) {
	assert(this->world_side_length == 0);
	assert(side_length > 0);
	this->world_side_length = side_length;
	return *this;
}

WorldGenerator &WorldGenerator::with_room_size(unsigned min_side_length, unsigned max_side_length) {
	assert(chunk_side_length > 0 && "Chunk size needs to be initialized before room size");
	assert(min_side_length < max_side_length);
	assert(min_side_length > 0);
	this->min_room_size = min_side_length;
	this->max_room_size = max_side_length;
	return *this;
}

World WorldGenerator::generate() {
	// TODO: the rest of the fucking owl
	World world{};
	Character character{Character(world, {0,0}, CharacterData {
		.health = 1,
		.damage = 1,
		.sprite = 0,
		.logic = null_character_logic_function
	})};
	character.data.logic(character);
	world.characters.push_back(character);
	return world;
}
}
