#include <SDL2/SDL.h>
#include "core/renderer.h"
#include "core/world.h"

using namespace rogue;

int main(int argc, char *argv[]) {
	World world{WorldGenerator().generate()};
	RenderData data{RenderDataSetup()
		.with_window("roguelike", SDL_WINDOW_ALLOW_HIGHDPI | SDL_WINDOW_FULLSCREEN)
		.with_renderer(SDL_RENDERER_ACCELERATED)
		.with_resource_path("resources/")
		.with_sprite("wizard.png")
		.build()
	};
	Render::provide_render_data(data);
	SDL_Event evt;
	for(;;) {
		Render::clear({0, 0});
		/*
		Render::draw({0, 0}, 0);
		Render::draw({1, 0}, 0);
		Render::draw({2, 0}, 0);
		Render::draw({3, 0}, 0);
		*/
		world.render();
		Render::present();
		if(SDL_WaitEvent(&evt)) {
			if(evt.type == SDL_QUIT) {
				goto main_loop;
			}
		}
	} main_loop:
	return 0;
}
